﻿using System;
using System.Collections;
using System.Collections.Generic;

namespace GenericConstraints
{
    // Adapted from Bart de Smet: C# 5.0 unleashed, Sams, page 723
    public class OrderedList<T> : IEnumerable<T> where T : IComparable<T>
    {

        private readonly IList<T> _elements = new List<T>();

        public void Add(T element)
        {
            int i = 0;
            while (i < _elements.Count)
            {
                if (_elements[i].CompareTo(element) >= 0)
                {
                    break;
                }
                i++;
            }
            _elements.Insert(i, element);
        }

        public T Get(int index)
        {
            return _elements[index];
        }

        public IEnumerator<T> GetEnumerator()
        {
            return _elements.GetEnumerator();
        }

        public override string ToString()
        {
            return _elements.ToString();
        }

        IEnumerator IEnumerable.GetEnumerator()
        {
            return GetEnumerator();
        }
    }
}
