﻿using System;

namespace GenericConstraints
{
    public class Student : IComparable<Student>, IEquatable<Student>
    {
        private static int _nextId = 0;
        private readonly int _id;
        public String Name { get; set; }

        public Student()
        {
            this._id = _nextId++;
        }

        public int Id { get { return _id; } }

        public int CompareTo(Student other)
        {
            //return this.id - other.id;
            return this.Name.CompareTo(other.Name);
        }

        public bool Equals(Student other)
        {
            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;
            return _id == other._id;
        }

        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            if (obj.GetType() != this.GetType()) return false;
            return Equals((Student) obj);
        }

        public override int GetHashCode()
        {
            return _id;
        }
    }
}
